#ifndef _REFERENCE_DATA_H_
#define _REFERENCE_DATA_H_

#include "load_data.h"
#include "util.h"
/**
 * @struct Linked list of masked regions
 * on the ref sequence.
 */

typedef struct MaskedRegionType {
  /** first pos masked */
  int start;
  /** last pos masked */
  int end;
  /** next one */
  struct MaskedRegionType* next;
} MaskedRegionType;

/**
 * @struct Ref sequence descriptor
 */

typedef struct ReferenceDBType {
  /** fasta name */
  char* name;
  /** size (nucleotides ? [FIXME] ) */
  int size;
  /** */
#ifndef NUCLEOTIDES
  CODE_TYPE first_base;
#endif
  /** */
  CODE_TYPE* sequence;
  /** list of masked regions along the genome [FIXME : remind me why ...] */
  MaskedRegionType* masked_regions;
} ReferenceDBType;

/**
 * Load reference sequence
 */
int load_reference_db(const char* reference_filename, ReferenceDBType** db);

/**
 * Destroys a read database
 */
void clear_reference_db(ReferenceDBType* db);

#endif /* _REFERENCE_DATA_H_ */
